#ifndef __YTLSmartArray_h__
#define __YTLSmartArray_h__

#include "yaneMacro.h"

//	x[XƂȂIuWFNg
//	iǂȃX}[g|C^ɕϊłj
class smart_aobj {
public:
	virtual ~smart_aobj() {};
};

template<class T> class smart_array : public smart_aobj {
public:
	template <class S>
	smart_array(S *_P,int nMax=0,bool bOwner=false)
		: m_lpa(_P) , m_nSize(sizeof(S)) , m_nMax(nMax) {
		if (bOwner) {
			m_lpPrev = m_lpNext = this;
		} else {
			m_lpPrev = m_lpNext = NULL;
		}
	}
	//	fBtHgł͏LȂ

	//	NULLƁAo֐ev[gɓ삵Ȃ
	smart_array(void)
		: m_lpa(NULL) , m_nSize(0) , m_nMax(0),
			m_lpPrev(NULL), m_lpNext(NULL){}

	smart_array(const smart_array<T>& _Y) {
		//	LƂ̂H
		if (_Y.m_lpPrev!=NULL) {
			//	L`FCɒǉB
			m_lpPrev = const_cast<smart_array<T>*>(&_Y);
			m_lpNext = const_cast<smart_array<T>*>(&_Y)->m_lpNext;
			const_cast<smart_array<T>*>(&_Y)->m_lpNext->m_lpPrev = this;
			const_cast<smart_array<T>*>(&_Y)->m_lpNext = this;
		} else {
			m_lpPrev = m_lpNext = NULL;
		}
		m_lpa	= _Y.m_lpa;
		m_nSize = _Y.m_nSize;
		m_nMax	= _Y.m_nMax;
	}
	smart_array<T>& operator=(const smart_array<T>& _Y) {
		if (this != &_Y) {
			Delete();
			//	LƂ̂H
			if (_Y.m_lpPrev!=NULL) {
				//	L`FCɒǉB
				m_lpPrev = const_cast<smart_array<T>*>(&_Y);
				m_lpNext = const_cast<smart_array<T>*>(&_Y)->m_lpNext;
				const_cast<smart_array<T>*>(&_Y)->m_lpNext->m_lpPrev = this;
				const_cast<smart_array<T>*>(&_Y)->m_lpNext = this;
			}
			m_lpa	= _Y.m_lpa;
			m_nSize = _Y.m_nSize;
			m_nMax	= _Y.m_nMax;
		}
		return (*this);
	}
	template <class S>
	smart_array<T>& operator=(const S* _P) {
		//	EӒl̓|C^łāȀL҂ɂĂ͔Ȃ

		//	|C^ǂ̃`FbN͂Ȃc
		Delete();
		m_lpa	= const_cast<S*>(_P);	//	AbvLXg˂
		m_nSize = sizeof(S);
		m_nMax	= _Y.m_nMax;
		return (*this);
	}

	virtual ~smart_array() { Delete(); }
	T& operator*() const  {return *get(); }
	T* operator->() const {return get();  }

	//	z̗vf͈̓`FbN@\t
	T* get(int n=0) const {	//	nԖڂ̗vfʒuԂ
		WARNING(m_nMax!=0 && (n>=m_nMax || n<0),"zANZX͈͊Oł");
		return (T*)((BYTE*)m_lpa + n * m_nSize);
	}

	//	iʗAIȃ[X͍sȂȂj
	//	͊֘Asmart_array珊L𔍒DAT*Ԃ
	T* release() {
		//	ׂẴ`FC珊L𔍒D
		smart_array<T>* lpNext = m_lpNext;
		while (lpNext!=NULL) {
			lpNext->m_lpPrev = NULL;
			smart_array<T>* tmp = lpNext->m_lpNext;
			lpNext->m_lpNext = NULL;
			if (lpNext==this) break;
			lpNext = tmp;
		}
		return m_lpa;
	}

	//	iʗAIȉ͍sȂȂj
	//@́ȀL݂̂
	void Delete() {
		//	NLĂ̂H
		if (m_lpPrev) {
			//	LẲH
			if (m_lpPrev==this) {
				delete [] m_lpa;
			} else {
				//	L`FC؂藣
				m_lpPrev->m_lpNext = m_lpNext;
				m_lpNext->m_lpPrev = m_lpPrev;
			}
			m_lpPrev = m_lpNext = NULL;
		}
		m_lpa	= NULL;
		m_nMax	= 0;
	}

	//	LCX^X̒ǉ\
	void Add(int n){
		Delete();
//		if (n!=0) {	//	ȃ`FbN͂C
		m_lpa = new T[n];		//	x
		m_nSize = sizeof(T);
		m_lpPrev = m_lpNext = this;
		m_nMax	= n;
	}
	template <class S>
	void Add(S*_P,int nMax=0){			//	|[tBbNȌ^ł
		Delete();
		if (_P!=NULL) {
			m_lpa	= _P;
			m_nSize = sizeof(S);
			m_lpPrev = m_lpNext = this;
			m_nMax = nMax;
		}
	}
	//	̂Q̊֐Pɂ܂Ƃ߂
	//	new T̕ŁAT ۃNXƃRpCG[ɂȂB

	//	I[i[ł邩Ԃ֐
	bool	IsOwner() const { return m_lpPrev!=NULL; }
	//	A\AƂI[i[ݒ肷邱Ƃ͏oȂ

	//	̂͂܂ׂłȂA
	//	ꉞT*ƃRp`reBۂB
	operator T* () const { return get(); }

	//	SȔzANZX
	T& operator [] (int n) {
		//	zւ̎QƂ͔͈̓`FbNsȂA
		//	X}[g|C^쐬ĕԂiƈSȂ̂
		//	ɃptH[}X͈j
		return *get(n);
	}

/*
	//	smart_arrayԂ̔r\(ۂɎwĂIuWFNgr)

	bool operator==(const smart_array<T>& _X) const
		{return (m_lpa == _X.m_lpa); }
	bool operator!=(const smart_array<T>& _X) const
		{return (!(*this == _X)); }
	bool operator<(const smart_array<T>&  _X) const
		{return (m_lpa < _X.m_lpa);}
	bool operator>(const smart_array<T>&  _X) const
		{return (_X < *this); }
	bool operator<=(const smart_array<T>& _X) const
		{return (!(_X < *this)); }
	bool operator>=(const smart_array<T>& _X) const
		{return (!(*this < _X)); }

	//	RXgN^explicitɂĂȂ̂ŁA
	//	Öق̕ϊɂoperator==BɂȂȂ悤
	bool operator==(const T* lpa) const
		{return (m_lpa == lpa); }
	bool operator!=(const T* lpa) const
		{return (!(*this == lpa)); }
	bool operator<(const T*  lpa) const
		{return (m_lpa < lpa);}
	bool operator>(const T* lpa) const
		{return (lpa < *this); }
	bool operator<=(const T* lpa) const
		{return (!(lpa < *this)); }
	bool operator>=(const T* lpa) const
		{return (!(*this < lpa)); }
*/

	/////////////////////////////////////////////////////////////////
	//	Ƃ́Asmart_arrayIWi
	//	std::vectorɏĂقꂽ\Zbg낤

	void clear(){ Delete(); } //	obt@̂̉

	//	CX^X̐ǉ\
	void resize(int n){ m_lpPrev = m_lpNext = NULL; Add(new T[n],n); }

	//	TCYwɂRXgNg((new T[n])Ȃď̂̓_TCI)
	smart_array(int n) {
		m_lpPrev = m_lpNext = this;
		m_lpa	= new T[n];
		m_nSize = sizeof(T);
		m_nMax = n;
	}

	//--- ǉ '01/12/13  by enra ---
	int size() const { return m_nMax; }	// vfԂ
	//-------------------------------

	///////////////////////////////////////////////////////////////////////////////
	//	STLɔq`Ă[

	class iterator;
	iterator begin() { return iterator(m_lpa,0,m_nSize,m_nMax); }
	iterator end()   { return iterator(m_lpa,m_nMax,m_nSize,m_nMax); }
	//	end́AzTCY^ĂȂƐlԂȂ
	iterator At(int n) { return iterator(m_lpa,n,m_nSize,m_nMax); }

	class iterator {
	public:
		iterator() : m_lpa(NULL),m_nOff(0),m_nSize(0),m_nMax(0){}
		iterator(T*pT,int nOff,int nSize,int nMax) {
			m_lpa = pT; m_nOff = nOff; m_nSize = nSize; m_nMax = nMax;
		}
		T* operator*() const {
			WARNING(m_nMax!=0 && (m_nOff>=m_nMax || m_nOff<0),"iteratorł̃ANZXvfOł");
			return (T*)((BYTE*)m_lpa + m_nOff*m_nSize);
		}
		iterator& operator++() { inc(); return (*this); }
		iterator operator++(int) { iterator _Tmp = *this; inc(); return (_Tmp); }
		iterator& operator--() { dec(); return (*this); }
		iterator operator--(int) { iterator _Tmp = *this; dec(); return (_Tmp); }
		iterator& operator+=(int _N)
			{ m_nOff += _N; if (m_nOff>=m_nMax) m_nOff=m_nMax; return (*this); }
		iterator& operator-=(int _N)
			{ m_nOff -= _N; if (m_nOff<0) m_nOff=0; return (*this); }
		iterator operator+(int _N) const
			{iterator _Tmp = *this;
			return (_Tmp += _N); }
		iterator operator-(int _N) const
			{iterator _Tmp = *this;
			return (_Tmp -= _N); }
		T* operator[](int _N) const { return (*(*this + _N)); }
		bool operator==(const iterator& _X) const
			{return (m_lpa == _X.m_lpa && m_nOff == _X.m_nOff); }
		bool operator!=(const iterator& _X) const
			{return (!(*this == _X)); }
		bool operator<(const iterator& _X) const
			{return (m_lpa < _X.m_lpa
				|| m_lpa == _X.m_lpa && m_nOff < _X.m_nOff); }
		bool operator>(const iterator& _X) const
			{return (_X < *this); }
		bool operator<=(const iterator& _X) const
			{return (!(_X < *this)); }
		bool operator>=(const iterator& _X) const
			{return (!(*this < _X)); }
	///////////////////////////////////////////////////////////////////////////////
	protected:
		void dec() { /* if (m_nOff>0) */ m_nOff--; }
		//	}CiX́A~ȂقfobO₷OOG
		void inc() { if (m_nMax==0 || m_nOff<=m_nMax) m_nOff++; }
		//	m_nOffend()w

	private:
		T*	m_lpa;
		int m_nOff;		//	݃|CgĂvfCfbNX
		int	m_nSize;	//	vfTCY
		int m_nMax;		//	őTCY
	};

private:
	T		*m_lpa;		//	|C^
	int		m_nSize;	//	vfTCY
	int		m_nMax;		//	zTCYĂ(0:`)

	//	`FCioXgjƂŏL𖾂炩ɂ
	//	i0Ȃ΁ALĂȂj
	smart_array<T>* m_lpPrev;
	smart_array<T>* m_lpNext;
};

#endif
