#ifndef __YTLSmartPtr_h__
#define __YTLSmartPtr_h__

//	x[XƂȂIuWFNg
//	iǂȃX}[g|C^ɕϊłj
class smart_obj {
public:
	virtual ~smart_obj() {};
};

template<class T> class smart_ptr : public smart_obj {
public:
	smart_ptr(T *_P = NULL,bool bOwner = false)
		:  m_lp(_P) {
			if (bOwner) {
				m_lpPrev = m_lpNext = this;
			} else {
				m_lpPrev = m_lpNext = NULL;
			}
		}
	//	fBtHgł͏LȂ
	//	iauto_ptrƂ̈ႢɒӁIj

	smart_ptr(const smart_ptr<T>& _Y) {
		//	LƂ̂H
		if (_Y.m_lpPrev!=NULL) {
			//	L`FCɒǉB
			m_lpPrev = const_cast<smart_ptr<T>*>(&_Y);
			m_lpNext = const_cast<smart_ptr<T>*>(&_Y)->m_lpNext;
			const_cast<smart_ptr<T>*>(&_Y)->m_lpNext->m_lpPrev = this;
			const_cast<smart_ptr<T>*>(&_Y)->m_lpNext = this;
		} else {
			m_lpPrev = NULL;
			m_lpNext = NULL;
		}
		m_lp = _Y.m_lp;
	}
	smart_ptr<T>& operator=(const smart_ptr<T>& _Y) {
		if (this != &_Y) {
			Delete();
			//	LƂ̂H
			if (_Y.m_lpPrev!=NULL) {
				//	L`FCɒǉB
				m_lpPrev = const_cast<smart_ptr<T>*>(&_Y);
				m_lpNext = const_cast<smart_ptr<T>*>(&_Y)->m_lpNext;
				const_cast<smart_ptr<T>*>(&_Y)->m_lpNext->m_lpPrev = this;
				const_cast<smart_ptr<T>*>(&_Y)->m_lpNext = this;
			}
			m_lp = _Y.m_lp;
		}
		return (*this);
	}
	smart_ptr<T>& operator=(const T* _P) {
		//	EӒl̓|C^łāȀL҂ɂĂ͔Ȃ

		//	|C^ǂ̃`FbN͂Ȃc
		Delete();
		m_lp = const_cast<T*>(_P);
		m_lpPrev = m_lpNext = NULL;
		return (*this);
	}

	virtual ~smart_ptr() { Delete(); }
	T& operator*() const  {return *get(); }
	T* operator->() const {return get();  }
	T* get() const { return m_lp; }

	//	iʗAIȃ[X͍sȂȂj
	//	͊֘Asmart_ptr珊L𔍒DAT*Ԃ
	T* release() {
		//	ׂẴ`FC珊L𔍒D
		smart_ptr<T>* lpNext = m_lpNext;
		while (lpNext!=NULL) {
			lpNext->m_lpPrev = NULL;
			smart_ptr<T>* tmp = lpNext->m_lpNext;
			lpNext->m_lpNext = NULL;
			if (lpNext==this) break;
			lpNext = tmp;
		}
		return m_lp;
	}

	//	iʗAIȉ͍sȂȂj
	//@́ȀL݂̂
	virtual void Delete() {
		//	NLĂ̂H
		if (m_lpPrev) {
#ifdef _DEBUG
			if ( m_lpPrev->m_lp == (LPVOID)0xdddddddd ){
				WARNING("true","ς݂̃`FCɃANZX");
				m_lpPrev = m_lpNext = this;
			}
#endif
			//	LẲH
			if (m_lpPrev==this) {
				delete m_lp;
			} else {
				//	L`FC؂藣
				m_lpPrev->m_lpNext = m_lpNext;
				m_lpNext->m_lpPrev = m_lpPrev;
			}
			m_lpPrev = m_lpNext = NULL;
		}
		m_lp = NULL;
	}

	//	LCX^X̒ǉ\
	void Add(){
		Delete();
		m_lp = new T;		//	x
		m_lpPrev = m_lpNext = this;
	}
	//	LCX^X̒ǉ\
	void Add(T*_P){			//	|[tBbNȌ^ł
		Delete();
		if (_P!=NULL) {
			m_lp	= _P;
			m_lpPrev = m_lpNext = this;
		}
	}
	//	̂Q̊֐Pɂ܂Ƃ߂
	//	new T̕ŁAT ۃNXƃRpCG[ɂȂB

	//	I[i[ł邩Ԃ֐
	bool	IsOwner() const { return m_lpPrev!=NULL; }
	//	A\AƂI[i[ݒ肷邱Ƃ͏oȂ

	//	̂͂܂ׂłȂA
	//	ꉞT*ƃRp`reBۂB
	operator T* () const { return get(); }

	//@yaneSDK3rdƎĂ
	bool	isNull() const { return get()==NULL; }
/*
	//	smart_ptrԂ̔r\(ۂɎwĂIuWFNgr)

	bool operator==(const smart_ptr<T>& _X) const
		{return (m_lp == _X.m_lp); }
	bool operator!=(const smart_ptr<T>& _X) const
		{return (!(*this == _X)); }
	bool operator<(const smart_ptr<T>&  _X) const
		{return (m_lp < _X.m_lp);}
	bool operator>(const smart_ptr<T>&  _X) const
		{return (_X < *this); }
	bool operator<=(const smart_ptr<T>& _X) const
		{return (!(_X < *this)); }
	bool operator>=(const smart_ptr<T>& _X) const
		{return (!(*this < _X)); }

	//	RXgN^explicitɂĂȂ̂ŁA
	//	Öق̕ϊɂoperator==BɂȂȂ悤
	bool operator==(const T* lp) const
		{return (m_lp == lp); }
	bool operator!=(const T* lp) const
		{return (!(*this == lp)); }
	bool operator<(const T*  lp) const
		{return (m_lp < lp);}
	bool operator>(const T* lp) const
		{return (lp < *this); }
	bool operator<=(const T* lp) const
		{return (!(lp < *this)); }
	bool operator>=(const T* lp) const
		{return (!(*this < lp)); }
*/

protected:
	T		*m_lp;

	//	`FCioXgjƂŏL𖾂炩ɂ
	//	iNULLȂ΁ALĂȂj
	smart_ptr<T>* m_lpPrev;
	smart_ptr<T>* m_lpNext;
};

#endif
