#include <windows.h>
//#include <stdlib.h>
#define EXPORT extern "C" __declspec(dllexport)

struct SDllTable {
	LPSTR	lpFuncName;
	LONG	(*lpFunc)(LONG*);
};

EXPORT long sumary (long *p) {
  long size;
  long* ary;
  int i,sum;

  size = p[0];
  ary  = (long *)p[1];

  sum=0;
  for(i=0; i<size; i++) {
    sum += ary[i];
  }
  return sum;

}

EXPORT long adrary (long *p) {
  return p[0];
}

EXPORT long hantei (long *p) {
  long jx,jy,jw,jh;
  long tnum;
  long *tf, *tx, *ty, *tw, *th;
  long x,y,w,h;
  int i,px0,px1,py0,py1,flag;

  jx   = p[0];
  jy   = p[1];
  jw   = p[2];
  jh   = p[3];
  tnum = p[4];
  tf = (long *)p[5];
  tx = (long *)p[6];
  ty = (long *)p[7];
  tw = (long *)p[8];
  th = (long *)p[9];

  flag=-1;
  for(i=0; i<tnum; i++) {
    if (tf[i]==0) continue;
    x = tx[i]; y = ty[i]; w = tw[i]; h = th[i];
	px0 = (x<=jx)&&(jx<=(x+w-1));
	px1 = (x<=(jx+jw-1))&&((jx+jw-1)<=(x+w-1));
	py0 = (y<=jy)&&(jy<=(y+h-1));
	py1 = (y<=(jy+jh-1))&&((jy+jh-1)<=(y+h-1));
	if ((px0&&py0)||(px1&&py0)||(px0&&py1)||(px1&&py1))
		{ flag = i; break; }
  }

  return flag;

}

EXPORT long hantei2 (long *p) {
  long jx,jy,jw,jh;
  long tnum;
  long *tf, *tx, *ty;
  long x,y,w,h;
  int i,px0,px1,py0,py1,flag;

  jx   = p[0];
  jy   = p[1];
  jw   = p[2];
  jh   = p[3];
  tnum = p[4];
  tf = (long *)p[5];
  tx = (long *)p[6];
  ty = (long *)p[7];
  w = p[8];
  h = p[9];

  flag=-1;
  for(i=0; i<tnum; i++) {
    if (tf[i]==0) continue;
    x = tx[i]; y = ty[i];
/*	px0 = (x<=jx)&(jx<=(x+w-1));
	px1 = (x<=(jx+jw-1))&((jx+jw-1)<=(x+w-1));
	py0 = (y<=jy)&(jy<=(y+h-1));
	py1 = (y<=(jy+jh-1))&((jy+jh-1)<=(y+h-1)); */
	px0 = (jx<=x)&(x<=(jx+jw-1));
	px1 = (jx<=(x+w-1))&((x+w-1)<=(jx+jw-1));
	py0 = (jy<=y)&(y<=(jy+jh-1));
	py1 = (jy<=(y+h-1))&((y+h-1)<=(jy+jh-1));

	if ((px0&py0)||(px1&py0)||(px0&py1)||(px1&py1))
		{ flag = i; break; }
  }

  return flag;

}

EXPORT long hantei3 (long *p) {
  long jx,jy,jw,jh;
  long tnum;
  long *tf, *tx, *ty, *tt, *ta;
  long x,y,w,h;
  long tt1, tt2;
  int i,px0,px1,py0,py1,flag;
  

  jx   = p[0];
  jy   = p[1];
  jw   = p[2];
  jh   = p[3];
  tnum = p[4];
  tf = (long *)p[5];
  tx = (long *)p[6];
  ty = (long *)p[7];
  w = p[8];
  h = p[9];
  tt = (long *)p[10];
  tt1 = p[11];
  tt2 = p[12];
  ta = (long *)p[13];

  flag = 0;
  for(i=0; i<tnum; i++) {
  	ta[i] = 0;
  	if (!(tf[i]&1)) continue;
  	if ((tt[i]>=tt1)&&(tt[i]<=tt2)) {
	    x = tx[i]; y = ty[i];
		px0 = (jx<=x)&(x<=(jx+jw-1));
		px1 = (jx<=(x+w-1))&((x+w-1)<=(jx+jw-1));
		py0 = (jy<=y)&(y<=(jy+jh-1));
		py1 = (jy<=(y+h-1))&((y+h-1)<=(jy+jh-1));
	  	if ((px0&py0)||(px1&py0)||(px0&py1)||(px1&py1)) {
	  		ta[i] = 1;
	  		flag = 1;
	  	}
  	}
  }

  return flag;
}


extern "C" __declspec( dllexport ) SDllTable* InquireFunction(void){
	static SDllTable S[] = {
		//	ɁADLLŎgĂ֐񋓂
		"SumArray",sumary,
		"AddrArray",adrary,
		"AtariHantei",hantei,
		"AtariHantei2",hantei2,
		"AtariHantei3",hantei3,
		//	ygs2k"FillMemory"Ƃ֐ǉB
		//	FillMemoryŌĂяốADLLfFillMemoryłB
		NULL,NULL	// ŌNULL,NULL
	};
	return &S[0];
}

//int WINAPI DllMain(HINSTANCE hInst, DWORD fdwReason, PVOID pvReserved)
int WINAPI DllMain(HINSTANCE, DWORD, PVOID)
{ return TRUE; }
