#ifndef FOE_H_
#define FOE_H_

#include "MyRunner.h"
extern int tama;
extern double multi0;

class Foe {
  public:
    /* members */
	int flag; // (0: 1:Vv 2:ANVt)
	double x,y;
	double dx,dy;
	int type; // OtBbN\^Cv
	int oya;  // e̒eNo. (ƗVvȅꍇ -1)
	double dir;
	double multi; //ex{
	long term;
	//	double dir,spd;
	//	int no;
	MyRunner *com;

	/* methods */
	Foe() {
		this->flag = 0;
		this->type = 0;
		this->x  = 0.0;
		this->y  = 0.0;
		this->dir = 0.0;
		this->dx = 0.0;
		this->dy = 0.0;
		this->oya = -1;
		this->multi = multi0;
		this->term = 0;
	}
	void init(double x, double y, double dir, double dx, double dy, int type, int oya, double multi) { //Vve
		flag = 1;
		this->x = x;
		this->y = y;
		this->dir = dir;
		this->dx = dx;
		this->dy = dy;
		this->type = type;
		this->com = NULL;
		this->oya = oya;
		this->multi = multi;
		this->term = 0;
		tama++;
	}
	void init(double x, double y, double dir, MyRunner *com, int type, int oya, double multi, int f) { //ANVe
		flag = f;
		this->x = x;
		this->y = y;
		this->dir = dir;
		this->dx = 0.0;
		this->dy = 0.0;
		this->type = type;
		this->com = com;
		this->oya = oya;
		this->multi = multi;
		this->term = 0;
		tama++;
	}
	void run() {
		term++;
		if(flag==1) {
			x += dx * multi;
			y += dy * multi;
		} else if(flag>=2) {
			com->run();
//			if ((com->isEnd())||(flag==0)) {
			if (flag==0) {
				vanish();
			} else if (com->isEnd()) {
				if (com->getBulletSpeed() == 0) vanish();
				else {
					flag = 1;
					dx = com->getBulletSpeedX(); x += dx * multi;
					dy = com->getBulletSpeedY(); y += dy * multi;
					dir = com->getBulletDirection() + com->rot;
					if(com != NULL) {
						delete com;
						com = NULL;
					}
				}
			} else {
				dx = com->getBulletSpeedX(); x += dx * multi;
				dy = com->getBulletSpeedY(); y += dy * multi;
				/*
				x += com->getBulletSpeedX() * multi;
				y += com->getBulletSpeedY() * multi;
				*/
				dir = com->getBulletDirection() + com->rot;
			}
		}
	}

	void vanish() {
		flag = 0;
		if(com != NULL) {
			delete com;
			com = NULL;
		}
		tama--;
	}
	void vanish2() {
		flag = 0;
//		tama--;
	}
	~Foe() {
		delete com;
	}
};

#endif
