#include "FoeSystem.h"
extern double rot0;

//Vve
//(1)eWRs[Đ
int FoeSystem::simple(int no, double direction, double dx, double dy) {
	int no2 = akiBullet();
	if(no2 >= 0) {
		foes[no2].init(foes[no].x, foes[no].y, direction, dx, dy, foes[no].type + 1, foes[no].oya, foes[no].multi);
	}
	return no2;
}
//(2)Ww肵Đ(VKpBxy̑xw)
int FoeSystem::simple(double x, double y, double dx, double dy, long type) {
	double r;
	int no = akiBullet();

	if(no >= 0) {
//		double direction = atan2(-dx, dy)/M_PI*180 + 180;
		if((dx==0)&&(dy==0)) {
			r = 180;
		} else {
			/*
			r = atan2(-dx, dy)/M_PI*180 + 180 - rot0;
			if (rot0 < 0) r += 360;
			*/
			r = atan2(-dx, dy)/M_PI*180 + 180;
		}
		foes[no].init(x, y, r, dx, dy, type, -1, multi0);
	}

	return no;
}
//(3)Ww肵Đ(VKpBpx{xw)
int FoeSystem::simple2(double x, double y, double dir, double spd, long type) {
	int no = akiBullet();
	if(no >= 0) {
		double dx = sin((dir+rot0)/180*3.14)*spd;
		double dy = -cos((dir+rot0)/180*3.14)*spd;
		foes[no].init(x, y, dir+rot0, dx, dy, type, -1, multi0);
		
	}
	return no;
}

//ANVe
//(1)eWRs[Đ(BulletMLStateႤ)
int FoeSystem::action(int no, BulletMLState* state, double direction, double speed, double rank, double rot) {
	int no2 = akiBullet();
	if(no2 >= 0) {
		foes[no2].init(foes[no].x, foes[no].y, direction, new MyRunner(no2,state,direction,speed,rank,rot), foes[no].type + 1, foes[no].oya, foes[no].multi, 3);
	}
	return no2;
}

//(2)Ww肵Đ(VKpBBullerMLParserႤ)
int FoeSystem::action(double x, double y, BulletMLParserTinyXML* parser, double rank, long type, double multi, double rot) {
	int no = akiBullet();
	if(no >= 0) {
		foes[no].init(x, y, 180.0, new MyRunner(no, parser, rank, rot), type, no, multi, 2);
	}
	return no;
}

int FoeSystem::akiBullet(void) {
	for(int i=0; i<max; i++) {
		if (foes[i].flag == 0) return i;
	}
	return -1;
}
void FoeSystem::run(void) {
	for(int i=0; i<max; i++) {
		if (foes[i].flag > 0) foes[i].run();
	}
}
